numbers = [1, 9, 3, 12, -3, 10]

# --------------------------------------------------------
# A Python list comprehension:

doubled_numbers = [n * 2 for n in numbers]

# is syntactic sugar for a good old for loop:

# doubled_numbers = []
# for n in numbers:
#     doubled_numbers.append(n * 2)

# --------------------------------------------------------
# List comprehensions are a little language all their own.
# This Python list comprehension:

doubled_numbers_v2 = [n * 2 for n in numbers if n % 2 == 1]

# is sugar for:

# doubled_numbers_v2 = []
# for n in numbers:
#     if n % 2 == 1:
#         doubled_numbers_v2.append(n * 2)

# --------------------------------------------------------

